Index: /LMDZ5/branches/testing/libf/phylmd/vertical_layers_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/vertical_layers_mod.F90	(revision 2408)
+++ /LMDZ5/branches/testing/libf/phylmd/vertical_layers_mod.F90	(revision 2408)
@@ -0,0 +1,46 @@
+! $Id: $
+
+MODULE vertical_layers_mod
+
+   REAL,SAVE             :: preff  ! reference surface pressure (Pa)
+   REAL,SAVE             :: scaleheight ! atmospheric reference scale height (km)
+   REAL,SAVE,ALLOCATABLE :: ap(:) ! hybrid (pressure contribution) coordinate 
+                                  ! at layer interfaces (Pa)
+   REAL,SAVE,ALLOCATABLE :: bp(:) ! hybrid (sigma contribution) coordinate 
+                                  ! at layer interfaces (Pa)
+   REAL,SAVE,ALLOCATABLE :: presnivs(:) ! reference pressure at mid-layer (Pa),
+                                        ! based on preff, ap and bp
+   REAL,SAVE,ALLOCATABLE :: pseudoalt(:) ! pseudo-altitude of model layers (km),
+                                         ! based on preff and scaleheight
+   
+!$OMP THREADPRIVATE(preff,scaleheight,ap,bp,presnivs,pseudoalt)
+
+
+CONTAINS
+
+  SUBROUTINE init_vertical_layers(nlayer,preff_,scaleheight_,ap_,bp_,&
+                                 presnivs_, pseudoalt_)
+    IMPLICIT NONE
+    INTEGER,INTENT(IN) :: nlayer ! number of atmospheric layers
+    REAL,INTENT(IN)    :: preff_ ! reference surface pressure (Pa)
+    REAL,INTENT(IN)    :: scaleheight_ ! atmospheric scale height (km)
+    REAL,INTENT(IN)    :: ap_(nlayer+1) ! hybrid coordinate at interfaces
+    REAL,INTENT(IN)    :: bp_(nlayer+1) ! hybrid coordinate at interfaces
+    REAL,INTENT(IN)    :: presnivs_(nlayer) ! Appproximative pressure of atm. layers (Pa)
+    REAL,INTENT(IN)    :: pseudoalt_(nlayer) ! pseudo-altitude of atm. layers (km)
+  
+    ALLOCATE(ap(nlayer+1))
+    ALLOCATE(bp(nlayer+1))
+    ALLOCATE(presnivs(nlayer))
+    ALLOCATE(pseudoalt(nlayer))
+  
+    preff = preff_
+    scaleheight=scaleheight_
+    ap(:) = ap_(:)
+    bp(:) = bp_(:)
+    presnivs(:) = presnivs_(:)
+    pseudoalt(:) = pseudoalt_(:)
+
+  END SUBROUTINE init_vertical_layers
+
+END MODULE vertical_layers_mod
Index: /LMDZ5/branches/testing/libf/phylmd/wake.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/wake.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/wake.F90	(revision 2408)
@@ -2,9 +2,12 @@
 ! $Id$
 
-SUBROUTINE wake(p, ph, pi, dtime, sigd_con, te0, qe0, omgb, dtdwn, dqdwn, &
-    amdwn, amup, dta, dqa, wdtpbl, wdqpbl, udtpbl, udqpbl, deltatw, deltaqw, &
-    dth, hw, sigmaw, wape, fip, gfl, dtls, dqls, ktopw, omgbdth, dp_omgb, &
-    wdens, tu, qu, dtke, dqke, dtpbl, dqpbl, omg, dp_deltomg, spread, cstar, &
-    d_deltat_gw, d_deltatw2, d_deltaqw2)
+SUBROUTINE wake(p, ph, pi, dtime, sigd_con, &
+                te0, qe0, omgb, &
+                dtdwn, dqdwn, amdwn, amup, dta, dqa, &
+                wdtpbl, wdqpbl, udtpbl, udqpbl, &
+                deltatw, deltaqw, dth, hw, sigmaw, wape, fip, gfl, &
+                dtls, dqls, ktopw, omgbdth, dp_omgb, wdens, tu, qu, &
+                dtke, dqke, dtpbl, dqpbl, omg, dp_deltomg, spread, cstar, &
+                d_deltat_gw, d_deltatw2, d_deltaqw2)
 
 
@@ -20,4 +23,5 @@
   USE dimphy
   use mod_phys_lmdz_para
+  USE print_control_mod, ONLY: prt_level
   IMPLICIT NONE
   ! ============================================================================
@@ -110,40 +114,41 @@
   ! -------------------------------------------------------------------------
 
-  include "dimensions.h"
   include "YOMCST.h"
   include "cvthermo.h"
-  include "iniprint.h"
 
   ! Arguments en entree
   ! --------------------
 
-  REAL, DIMENSION (klon, klev) :: p, pi
-  REAL, DIMENSION (klon, klev+1) :: ph, omgb
-  REAL dtime
-  REAL, DIMENSION (klon, klev) :: te0, qe0
-  REAL, DIMENSION (klon, klev) :: dtdwn, dqdwn
-  REAL, DIMENSION (klon, klev) :: wdtpbl, wdqpbl
-  REAL, DIMENSION (klon, klev) :: udtpbl, udqpbl
-  REAL, DIMENSION (klon, klev) :: amdwn, amup
-  REAL, DIMENSION (klon, klev) :: dta, dqa
-  REAL, DIMENSION (klon) :: sigd_con
+  REAL, DIMENSION (klon, klev),     INTENT(IN)          :: p, pi
+  REAL, DIMENSION (klon, klev+1),   INTENT(IN)          :: ph, omgb
+  REAL,                             INTENT(IN)          :: dtime
+  REAL, DIMENSION (klon, klev),     INTENT(IN)          :: te0, qe0
+  REAL, DIMENSION (klon, klev),     INTENT(IN)          :: dtdwn, dqdwn
+  REAL, DIMENSION (klon, klev),     INTENT(IN)          :: wdtpbl, wdqpbl, udtpbl, udqpbl ! UNUSED
+  REAL, DIMENSION (klon, klev),     INTENT(IN)          :: amdwn, amup
+  REAL, DIMENSION (klon, klev),     INTENT(IN)          :: dta, dqa
+  REAL, DIMENSION (klon),           INTENT(IN)          :: sigd_con
+
+  !
+  ! Input/Output
+  REAL, DIMENSION (klon, klev),     INTENT(INOUT)       :: deltatw, deltaqw
+  REAL, DIMENSION (klon),           INTENT(INOUT)       :: sigmaw
 
   ! Sorties
   ! --------
 
-  REAL, DIMENSION (klon, klev) :: deltatw, deltaqw, dth
-  REAL, DIMENSION (klon, klev) :: tu, qu
-  REAL, DIMENSION (klon, klev) :: dtls, dqls
-  REAL, DIMENSION (klon, klev) :: dtke, dqke
-  REAL, DIMENSION (klon, klev) :: dtpbl, dqpbl
-  REAL, DIMENSION (klon, klev) :: spread
-  REAL, DIMENSION (klon, klev) :: d_deltatgw
-  REAL, DIMENSION (klon, klev) :: d_deltatw2, d_deltaqw2
-  REAL, DIMENSION (klon, klev+1) :: omgbdth, omg
-  REAL, DIMENSION (klon, klev) :: dp_omgb, dp_deltomg
-  REAL, DIMENSION (klon, klev) :: d_deltat_gw
-  REAL, DIMENSION (klon) :: hw, sigmaw, wape, fip, gfl, cstar
-  REAL, DIMENSION (klon) :: wdens
-  INTEGER, DIMENSION (klon) :: ktopw
+  REAL, DIMENSION (klon, klev),     INTENT(OUT)         :: dth
+  REAL, DIMENSION (klon, klev),     INTENT(OUT)         :: tu, qu
+  REAL, DIMENSION (klon, klev),     INTENT(OUT)         :: dtls, dqls
+  REAL, DIMENSION (klon, klev),     INTENT(OUT)         :: dtke, dqke
+  REAL, DIMENSION (klon, klev),     INTENT(OUT)         :: dtpbl, dqpbl
+  REAL, DIMENSION (klon, klev),     INTENT(OUT)         :: spread
+  REAL, DIMENSION (klon, klev),     INTENT(OUT)         :: d_deltatw2, d_deltaqw2
+  REAL, DIMENSION (klon, klev+1),   INTENT(OUT)         :: omgbdth, omg
+  REAL, DIMENSION (klon, klev),     INTENT(OUT)         :: dp_omgb, dp_deltomg
+  REAL, DIMENSION (klon, klev),     INTENT(OUT)         :: d_deltat_gw
+  REAL, DIMENSION (klon),           INTENT(OUT)         :: hw, wape, fip, gfl, cstar
+  REAL, DIMENSION (klon),           INTENT(OUT)         :: wdens
+  INTEGER, DIMENSION (klon),        INTENT(OUT)         :: ktopw
 
   ! Variables internes
@@ -1734,6 +1739,9 @@
       wape(i) = 0.
       cstar(i) = 0.
-      hw(i) = hwmin
-      sigmaw(i) = sigmad
+!!jyg   Outside subroutine "Wake" hw and sigmaw are zero when there are no wakes
+!!      hw(i) = hwmin                       !jyg
+!!      sigmaw(i) = sigmad                  !jyg
+      hw(i) = 0.                            !jyg
+      sigmaw(i) = 0.                        !jyg
       fip(i) = 0.
     ELSE
Index: /LMDZ5/branches/testing/libf/phylmd/write_histday_seri.h
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/write_histday_seri.h	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/write_histday_seri.h	(revision 2408)
@@ -7,5 +7,5 @@
 !
       ndex2d = 0
-      itau_w = itau_phy + itap + start_time * day_step / iphysiq
+      itau_w = itau_phy + itap + start_time * day_step_phy
 !
 ! Champs 2D:
@@ -20,20 +20,20 @@
       ok_msk=.FALSE.
       msk(1:klon)=pctsrf(1:klon,is_ter)
-      CALL moyglo_pondaire(klon, zx_tmp_fi2d, airephy,  &
-           ok_msk, msk, moyglo)
-      zx_tmp_fi2d(1:klon)=moyglo
-!
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d,zx_tmp_2d)
+      CALL moyglo_pondaire(klon, zx_tmp_fi2d, cell_area,  &
+           ok_msk, msk, moyglo)
+      zx_tmp_fi2d(1:klon)=moyglo
+!
+      CALL gr_fi_ecrit(1, klon,nbp_lon,nbp_lat, zx_tmp_fi2d,zx_tmp_2d)
       CALL histwrite(nid_day_seri,"bilTOA",itau_w, &
-                     zx_tmp_2d,iim*jjmp1,ndex2d)
-!
-      ok_msk=.FALSE.
-      CALL moyglo_pondaire(klon, bils, airephy,  &
-           ok_msk, msk, moyglo)
-      zx_tmp_fi2d(1:klon)=moyglo
-!
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d,zx_tmp_2d)
+                     zx_tmp_2d,nbp_lon*nbp_lat,ndex2d)
+!
+      ok_msk=.FALSE.
+      CALL moyglo_pondaire(klon, bils, cell_area,  &
+           ok_msk, msk, moyglo)
+      zx_tmp_fi2d(1:klon)=moyglo
+!
+      CALL gr_fi_ecrit(1, klon,nbp_lon,nbp_lat, zx_tmp_fi2d,zx_tmp_2d)
       CALL histwrite(nid_day_seri,"bils",itau_w, &
-                     zx_tmp_2d,iim*jjmp1,ndex2d)
+                     zx_tmp_2d,nbp_lon*nbp_lat,ndex2d)
 !
       DO k=1, klev
@@ -45,10 +45,10 @@
 !
       CALL moyglo_pondaima(klon, klev, zx_tmp_fi3d,  &
-           airephy, paprs, moyglo)
-      zx_tmp_fi2d(1:klon)=moyglo
-!
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d,zx_tmp_2d)
+           cell_area, paprs, moyglo)
+      zx_tmp_fi2d(1:klon)=moyglo
+!
+      CALL gr_fi_ecrit(1, klon,nbp_lon,nbp_lat, zx_tmp_fi2d,zx_tmp_2d)
       CALL histwrite(nid_day_seri,"ecin",itau_w, &
-                     zx_tmp_2d,iim*jjmp1,ndex2d) 
+                     zx_tmp_2d,nbp_lon*nbp_lat,ndex2d) 
 !
 !IM 151004 BEG
@@ -62,10 +62,10 @@
 !
       CALL moyglo_pondaima(klon, klev, zx_tmp_fi3d,  &
-           airephy, paprs, moyglo)
-      zx_tmp_fi2d(1:klon)=moyglo
-!
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d,zx_tmp_2d)
+           cell_area, paprs, moyglo)
+      zx_tmp_fi2d(1:klon)=moyglo
+!
+      CALL gr_fi_ecrit(1, klon,nbp_lon,nbp_lat, zx_tmp_fi2d,zx_tmp_2d)
       CALL histwrite(nid_day_seri,"momang",itau_w,zx_tmp_2d, &
-                     iim*jjmp1,ndex2d)
+                     nbp_lon*nbp_lat,ndex2d)
 !
 ! friction torque
@@ -76,23 +76,23 @@
 !
       ok_msk=.FALSE.
-      CALL moyglo_pondaire(klon, zx_tmp_fi2d, airephy,  &
-           ok_msk, msk, moyglo)
-      zx_tmp_fi2d(1:klon)=moyglo
-!
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d,zx_tmp_2d)
+      CALL moyglo_pondaire(klon, zx_tmp_fi2d, cell_area,  &
+           ok_msk, msk, moyglo)
+      zx_tmp_fi2d(1:klon)=moyglo
+!
+      CALL gr_fi_ecrit(1, klon,nbp_lon,nbp_lat, zx_tmp_fi2d,zx_tmp_2d)
       CALL histwrite(nid_day_seri,"frictor",itau_w,zx_tmp_2d, &
-                     iim*jjmp1,ndex2d)
+                     nbp_lon*nbp_lat,ndex2d)
 !
 ! mountain torque
 !
 !IM 190504 BEG
-      CALL gr_fi_dyn(1,klon,iim+1,jjm+1,airephy,airedyn)
-      CALL gr_fi_dyn(klev+1,klon,iim+1,jjm+1,paprs,padyn)
-      CALL gr_fi_dyn(1,klon,iim+1,jjm+1,rlat,rlatdyn)
+      CALL gr_fi_dyn(1,klon,nbp_lon+1,nbp_lat,cell_area,airedyn)
+      CALL gr_fi_dyn(klev+1,klon,nbp_lon+1,nbp_lat,paprs,padyn)
+      CALL gr_fi_dyn(1,klon,nbp_lon+1,nbp_lat,rlat,rlatdyn)
       mountor=0.
       airetot=0.
-      DO j = 1, jjmp1
-       DO i = 1, iim+1
-        ij=i+(iim+1)*(j-1)
+      DO j = 1, nbp_lat
+       DO i = 1, nbp_lon+1
+        ij=i+(nbp_lon+1)*(j-1)
         zx_tmp(ij)=0.
         DO k = 1, klev
@@ -113,17 +113,17 @@
 !
 !IM 190504 END
-      zx_tmp_2d(1:iim,1:jjmp1)=mountor
+      zx_tmp_2d(1:nbp_lon,1:nbp_lat)=mountor
       CALL histwrite(nid_day_seri,"mountor",itau_w,zx_tmp_2d, &
-                     iim*jjmp1,ndex2d)
+                     nbp_lon*nbp_lat,ndex2d)
 !
       ENDIF !(1.EQ.0) THEN
 !
 !
-      CALL gr_fi_dyn(1,klon,iim+1,jjm+1,airephy,airedyn)
-      CALL gr_fi_ecrit(1,klon,iim,jjmp1,airephy,zx_tmp_2d)
+      CALL gr_fi_dyn(1,klon,nbp_lon+1,nbp_lat,cell_area,airedyn)
+      CALL gr_fi_ecrit(1,klon,nbp_lon,nbp_lat,cell_area,zx_tmp_2d)
       airetot=0.
-!     DO j = 1, jjmp1
-!      DO i = 1, iim+1
-!       ij=i+(iim+1)*(j-1)
+!     DO j = 1, nbp_lat
+!      DO i = 1, nbp_lon+1
+!       ij=i+(nbp_lon+1)*(j-1)
 !       DO k = 1, klev
 !        airetot=airetot+airedyn(i,j)
@@ -134,11 +134,11 @@
 !
       DO i=1, klon
-       airetot=airetot+airephy(i)
+       airetot=airetot+cell_area(i)
       ENDDO
 !     IF(itap.EQ.1) PRINT*,'airetotphy=',airetot
 !
       airetot=0.
-      DO j=1, jjmp1
-       DO i=1, iim
+      DO j=1, nbp_lat
+       DO i=1, nbp_lon
         airetot=airetot+zx_tmp_2d(i,j)
        ENDDO
@@ -149,40 +149,40 @@
 !
       zx_tmp_fi2d(1:klon)=aam/airetot
-      CALL gr_fi_ecrit(1,klon,iim,jjmp1,zx_tmp_fi2d,zx_tmp_2d)
+      CALL gr_fi_ecrit(1,klon,nbp_lon,nbp_lat,zx_tmp_fi2d,zx_tmp_2d)
       CALL histwrite(nid_day_seri,"momang",itau_w,zx_tmp_2d, &
-                     iim*jjmp1,ndex2d)
+                     nbp_lon*nbp_lat,ndex2d)
 !
       zx_tmp_fi2d(1:klon)=torsfc/airetot
-      CALL gr_fi_ecrit(1,klon,iim,jjmp1,zx_tmp_fi2d,zx_tmp_2d)
+      CALL gr_fi_ecrit(1,klon,nbp_lon,nbp_lat,zx_tmp_fi2d,zx_tmp_2d)
       CALL histwrite(nid_day_seri,"torsfc",itau_w,zx_tmp_2d, &
-                     iim*jjmp1,ndex2d)
+                     nbp_lon*nbp_lat,ndex2d)
 !
 !IM 151004 END
 !
       CALL moyglo_pondmass(klon, klev, t_seri, &
-           airephy, paprs, moyglo)
-      zx_tmp_fi2d(1:klon)=moyglo
-!
-      CALL gr_fi_ecrit(1,klon,iim,jjmp1,zx_tmp_fi2d,zx_tmp_2d)
+           cell_area, paprs, moyglo)
+      zx_tmp_fi2d(1:klon)=moyglo
+!
+      CALL gr_fi_ecrit(1,klon,nbp_lon,nbp_lat,zx_tmp_fi2d,zx_tmp_2d)
       CALL histwrite(nid_day_seri,"tamv",itau_w, &
-                     zx_tmp_2d,iim*jjmp1,ndex2d)
-!
-      ok_msk=.FALSE.
-      CALL moyglo_pondaire(klon, paprs(:,1), airephy,  &
-           ok_msk, msk, moyglo)
-      zx_tmp_fi2d(1:klon)=moyglo
-!
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d,zx_tmp_2d)
+                     zx_tmp_2d,nbp_lon*nbp_lat,ndex2d)
+!
+      ok_msk=.FALSE.
+      CALL moyglo_pondaire(klon, paprs(:,1), cell_area,  &
+           ok_msk, msk, moyglo)
+      zx_tmp_fi2d(1:klon)=moyglo
+!
+      CALL gr_fi_ecrit(1, klon,nbp_lon,nbp_lat, zx_tmp_fi2d,zx_tmp_2d)
       CALL histwrite(nid_day_seri,"psol",itau_w, &
-                     zx_tmp_2d,iim*jjmp1,ndex2d)
-!
-      ok_msk=.FALSE.
-      CALL moyglo_pondaire(klon, evap, airephy,  &
-           ok_msk, msk, moyglo)
-      zx_tmp_fi2d(1:klon)=moyglo
-!
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d,zx_tmp_2d)
+                     zx_tmp_2d,nbp_lon*nbp_lat,ndex2d)
+!
+      ok_msk=.FALSE.
+      CALL moyglo_pondaire(klon, evap, cell_area,  &
+           ok_msk, msk, moyglo)
+      zx_tmp_fi2d(1:klon)=moyglo
+!
+      CALL gr_fi_ecrit(1, klon,nbp_lon,nbp_lat, zx_tmp_fi2d,zx_tmp_2d)
       CALL histwrite(nid_day_seri,"evap",itau_w, &
-                     zx_tmp_2d,iim*jjmp1,ndex2d)
+                     zx_tmp_2d,nbp_lon*nbp_lat,ndex2d)
 !
 !     DO i=1, klon
@@ -192,11 +192,11 @@
 !     ok_msk=.TRUE.
 !     msk(1:klon)=pctsrf(1:klon,is_ter)
-!     CALL moyglo_pondaire(klon, zx_tmp_fi2d, airephy, 
+!     CALL moyglo_pondaire(klon, zx_tmp_fi2d, cell_area, 
 !    .                     ok_msk, msk, moyglo)
 !     zx_tmp_fi2d(1:klon)=moyglo
 !
-!     CALL gr_fi_ecrit(1, klon,iim,jjmp1,zx_tmp_fi2d,zx_tmp_2d)
+!     CALL gr_fi_ecrit(1, klon,nbp_lon,nbp_lat,zx_tmp_fi2d,zx_tmp_2d)
 !     CALL histwrite(nid_day_seri,"SnowFrac",
-!    .               itau_w,zx_tmp_2d,iim*jjmp1,ndex2d) 
+!    .               itau_w,zx_tmp_2d,nbp_lon*nbp_lat,ndex2d) 
 !
 !     DO i=1, klon
@@ -208,11 +208,11 @@
 !     ok_msk=.TRUE.
 !     msk(1:klon)=pctsrf(1:klon,is_ter)
-!     CALL moyglo_pondaire(klon, zx_tmp_fi2d, airephy, 
+!     CALL moyglo_pondaire(klon, zx_tmp_fi2d, cell_area, 
 !    .     ok_msk, msk, moyglo)
 !     zx_tmp_fi2d(1:klon)=moyglo
 !
-!     CALL gr_fi_ecrit(1, klon,iim,jjmp1,zx_tmp_fi2d,zx_tmp_2d)
+!     CALL gr_fi_ecrit(1, klon,nbp_lon,nbp_lat,zx_tmp_fi2d,zx_tmp_2d)
 !     CALL histwrite(nid_day_seri,"snow_depth",itau_w,
-!    .               zx_tmp_2d,iim*jjmp1,ndex2d)
+!    .               zx_tmp_2d,nbp_lon*nbp_lat,ndex2d)
 !
       DO i=1, klon
@@ -222,11 +222,11 @@
       ok_msk=.TRUE.
       msk(1:klon)=pctsrf(1:klon,is_oce)
-      CALL moyglo_pondaire(klon, zx_tmp_fi2d, airephy,  &
-           ok_msk, msk, moyglo)
-      zx_tmp_fi2d(1:klon)=moyglo
-!
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d, zx_tmp_2d)
+      CALL moyglo_pondaire(klon, zx_tmp_fi2d, cell_area,  &
+           ok_msk, msk, moyglo)
+      zx_tmp_fi2d(1:klon)=moyglo
+!
+      CALL gr_fi_ecrit(1, klon,nbp_lon,nbp_lat, zx_tmp_fi2d, zx_tmp_2d)
       CALL histwrite(nid_day_seri,"tsol_"//clnsurf(is_oce), &
-                     itau_w,zx_tmp_2d,iim*jjmp1,ndex2d) 
+                     itau_w,zx_tmp_2d,nbp_lon*nbp_lat,ndex2d) 
 !
 !=================================================================
Index: /LMDZ5/branches/testing/libf/phylmd/write_paramLMDZ_phy.h
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/write_paramLMDZ_phy.h	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/write_paramLMDZ_phy.h	(revision 2408)
@@ -2,24 +2,24 @@
 ! calcul moyennes globales
 !
-       zx_tmp_fi2d=bils*airephy
-       CALL global_mean(zx_tmp_fi2d,airephy,.TRUE.,gbils)
-       zx_tmp_fi2d=evap*airephy
-       CALL global_mean(zx_tmp_fi2d,airephy,.TRUE.,gevap)
-       zx_tmp_fi2d(:)=fevap(:, is_ter)*airephy(:)
-       CALL global_mean(zx_tmp_fi2d,airephy,.TRUE.,gevapt)
-       zx_tmp_fi2d=zxfluxlat*airephy
-       CALL global_mean(zx_tmp_fi2d,airephy,.TRUE.,glat)
-       zx_tmp_fi2d=(topsw0-toplw0)*airephy
-       CALL global_mean(zx_tmp_fi2d,airephy,.TRUE.,gnet0)
-       zx_tmp_fi2d=(topsw-toplw)*airephy
-       CALL global_mean(zx_tmp_fi2d,airephy,.TRUE.,gnet)
-       zx_tmp_fi2d=(rain_fall+snow_fall)*airephy
-       CALL global_mean(zx_tmp_fi2d,airephy,.TRUE.,grain)
-       zx_tmp_fi2d=zxtsol*airephy
-       CALL global_mean(zx_tmp_fi2d,airephy,.TRUE.,gtsol)
-       zx_tmp_fi2d=zt2m*airephy
-       CALL global_mean(zx_tmp_fi2d,airephy,.TRUE.,gt2m)
-       zx_tmp_fi2d=prw*airephy
-       CALL global_mean(zx_tmp_fi2d,airephy,.TRUE.,gprw)
+       zx_tmp_fi2d=bils*cell_area
+       CALL global_mean(zx_tmp_fi2d,cell_area,.TRUE.,gbils)
+       zx_tmp_fi2d=evap*cell_area
+       CALL global_mean(zx_tmp_fi2d,cell_area,.TRUE.,gevap)
+       zx_tmp_fi2d(:)=fevap(:, is_ter)*cell_area(:)
+       CALL global_mean(zx_tmp_fi2d,cell_area,.TRUE.,gevapt)
+       zx_tmp_fi2d=zxfluxlat*cell_area
+       CALL global_mean(zx_tmp_fi2d,cell_area,.TRUE.,glat)
+       zx_tmp_fi2d=(topsw0-toplw0)*cell_area
+       CALL global_mean(zx_tmp_fi2d,cell_area,.TRUE.,gnet0)
+       zx_tmp_fi2d=(topsw-toplw)*cell_area
+       CALL global_mean(zx_tmp_fi2d,cell_area,.TRUE.,gnet)
+       zx_tmp_fi2d=(rain_fall+snow_fall)*cell_area
+       CALL global_mean(zx_tmp_fi2d,cell_area,.TRUE.,grain)
+       zx_tmp_fi2d=zxtsol*cell_area
+       CALL global_mean(zx_tmp_fi2d,cell_area,.TRUE.,gtsol)
+       zx_tmp_fi2d=zt2m*cell_area
+       CALL global_mean(zx_tmp_fi2d,cell_area,.TRUE.,gt2m)
+       zx_tmp_fi2d=prw*cell_area
+       CALL global_mean(zx_tmp_fi2d,cell_area,.TRUE.,gprw)
 !
 !$OMP MASTER
@@ -27,5 +27,5 @@
 !
       ndex2d = 0
-      itau_w = itau_phy + itap + int(start_time * day_step / iphysiq)
+      itau_w = itau_phy + itap + int(start_time * day_step_phy)
 !
 ! Variables globales
Index: /LMDZ5/branches/testing/libf/phylmd/yamada.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/yamada.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/yamada.F90	(revision 2408)
@@ -6,8 +6,4 @@
   USE dimphy
   IMPLICIT NONE
-  ! .......................................................................
-  ! ym#include "dimensions.h"
-  ! ym#include "dimphy.h"
-  ! .......................................................................
 
   ! dt : pas de temps
Index: /LMDZ5/branches/testing/libf/phylmd/yamada4.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/yamada4.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/yamada4.F90	(revision 2408)
@@ -5,10 +5,6 @@
     cd, q2, km, kn, kq, ustar, iflag_pbl)
   USE dimphy
+  USE print_control_mod, ONLY: prt_level
   IMPLICIT NONE
-  include "iniprint.h"
-  ! .......................................................................
-  ! ym#include "dimensions.h"
-  ! ym#include "dimphy.h"
-  ! .......................................................................
 
   ! dt : pas de temps
@@ -344,10 +340,12 @@
     ! print*,'Longueur ',l(:,:)
     DO k = 2, klev - 1
-      l(:, k) = max(l(:,k), 1.)
-      km(:, k) = l(:, k)*sqrt(q2(:,k))*sm(:, k)
-      q2(:, k) = q2(:, k) + dt*km(:, k)*m2(:, k)*(1.-rif(:,k))
-      q2(:, k) = min(max(q2(:,k),1.E-10), 1.E4)
-      q2(:, k) = 1./(1./sqrt(q2(:,k))+dt/(2*l(:,k)*b1))
-      q2(:, k) = q2(:, k)*q2(:, k)
+      DO ig = 1, ngrid
+        l(ig, k) = max(l(ig,k), 1.)
+        km(ig, k) = l(ig, k)*sqrt(q2(ig,k))*sm(ig, k)
+        q2(ig, k) = q2(ig, k) + dt*km(ig, k)*m2(ig, k)*(1.-rif(ig,k))
+        q2(ig, k) = min(max(q2(ig,k),1.E-10), 1.E4)
+        q2(ig, k) = 1./(1./sqrt(q2(ig,k))+dt/(2*l(ig,k)*b1))
+        q2(ig, k) = q2(ig, k)*q2(ig, k)
+      END DO
     END DO
 
@@ -496,8 +494,4 @@
   USE dimphy
   IMPLICIT NONE
-  ! .......................................................................
-  include "dimensions.h"
-  ! ccc#include "dimphy.h"
-  ! .......................................................................
 
   ! dt : pas de temps
@@ -572,8 +566,4 @@
   USE dimphy
   IMPLICIT NONE
-  ! .......................................................................
-  include "dimensions.h"
-  ! ccc#include "dimphy.h"
-  ! .......................................................................
 
   ! dt : pas de temps
Index: /LMDZ5/branches/testing/libf/phylmd/yamada_c.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/yamada_c.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/yamada_c.F90	(revision 2408)
@@ -5,12 +5,8 @@
      &   ,pu,pv,pt,d_u,d_v,d_t,cd,q2,km,kn,kq,d_t_diss,ustar &
      &   ,iflag_pbl,okiophys)
-      use dimphy
+      USE dimphy, ONLY: klon, klev
+      USE print_control_mod, ONLY: prt_level
       IMPLICIT NONE
-#include "iniprint.h"
 #include "YOMCST.h"
-!.......................................................................
-!ym#include "dimensions.h"
-!ym#include "dimphy.h"
-!.......................................................................
 !
 ! timestep : pas de temps
@@ -117,5 +113,6 @@
       real w2yam(klon,klev),t2yam(klon,klev)
       logical,save :: firstcall=.true.
-
+!$OMP THREADPRIVATE(firstcall)       
+      CHARACTER(len=20),PARAMETER :: modname="yamada_c"
 REAL, DIMENSION(klon,klev+1) :: fluxu,fluxv,fluxt
 REAL, DIMENSION(klon,klev+1) :: dddu,dddv,dddt
@@ -123,5 +120,4 @@
 REAL, DIMENSION(klon,klev+1) :: masseb,q2old,q2neg
 
-!$OMP THREADPRIVATE(firstcall)       
       frif(ri)=0.6588*(ri+0.1776-sqrt(ri*ri-0.3221*ri+0.03156))
       falpha(ri)=1.318*(0.2231-ri)/(0.2341-ri)
@@ -575,5 +571,5 @@
 
       else
-         stop'Cas nom prevu dans yamada4'
+         CALL abort_physic(modname,'Cas nom prevu dans yamada4',1)
 
       endif ! Fin du cas 8
Index: /LMDZ5/branches/testing/libf/phymar/Mod_PHY_AT_kkl.f90
===================================================================
--- /LMDZ5/branches/testing/libf/phymar/Mod_PHY_AT_kkl.f90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phymar/Mod_PHY_AT_kkl.f90	(revision 2408)
@@ -88,5 +88,6 @@
       real(kind=real8), SAVE,ALLOCATABLE ,dimension(:)    ::  P___AT  ! Auxiliary   Term               P                           [-]
       real(kind=real8), SAVE,ALLOCATABLE ,dimension(:)    ::  Q___AT  ! Auxiliary   Term               Q                           [-]
-      real*16         ,ALLOCATABLE ,dimension(:)    ::  X___AT  ! Auxiliary   Unknown            X                           [x]
+!      real*16         ,ALLOCATABLE ,dimension(:)    ::  X___AT  ! Auxiliary   Unknown            X                           [x]
+      double precision,ALLOCATABLE ,dimension(:)    ::  X___AT  ! Auxiliary   Unknown            X                           [x]
 
       real(kind=real8), SAVE,ALLOCATABLE ,dimension(:)    ::  LMO_AT  ! Monin-Obukhov     Length         (Grid Cell Average)       [m]
Index: /LMDZ5/branches/testing/libf/phymar/infotrac_phy.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phymar/infotrac_phy.F90	(revision 2408)
+++ /LMDZ5/branches/testing/libf/phymar/infotrac_phy.F90	(revision 2408)
@@ -0,0 +1,32 @@
+
+! $Id: $
+
+MODULE infotrac_phy
+
+! Infotrac for physics; for now contains the same information as infotrac for
+! the dynamics (could be further cleaned) and is initialized using values
+! provided by the dynamics
+
+! nqtot : total number of tracers and higher order of moment, water vapor and liquid included
+  INTEGER, SAVE :: nqtot
+!$OMP THREADPRIVATE(nqtot)
+ 
+CONTAINS
+
+  SUBROUTINE init_infotrac_phy(nqtot_)
+  ! transfer information on tracers from dynamics to physics
+  USE print_control_mod, ONLY: prt_level, lunout
+  IMPLICIT NONE
+    INTEGER,INTENT(IN) :: nqtot_
+
+    CHARACTER(LEN=30) :: modname="init_infotrac_phy"
+
+    nqtot=nqtot_
+  
+    IF(prt_level.ge.1) THEN
+      write(lunout,*) TRIM(modname)//": nqtot",nqtot
+    ENDIF
+    
+  END SUBROUTINE init_infotrac_phy
+
+END MODULE infotrac_phy
Index: /LMDZ5/branches/testing/libf/phymar/phyaqua_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phymar/phyaqua_mod.F90	(revision 2408)
+++ /LMDZ5/branches/testing/libf/phymar/phyaqua_mod.F90	(revision 2408)
@@ -0,0 +1,45 @@
+!
+! $Id: $
+!
+MODULE phyaqua_mod
+
+  IMPLICIT NONE
+
+CONTAINS
+
+  SUBROUTINE iniaqua(nlon, iflag_phys)
+
+  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+  !  Create an initial state (startphy.nc) for the physics
+  !  Usefull for idealised cases (e.g. aquaplanets or testcases)
+  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
+  USE phys_state_var_mod, ONLY: rlat, rlon, phys_state_var_init
+  USE mod_phys_lmdz_para, ONLY: klon_omp
+  USE geometry_mod, ONLY: longitude_deg, latitude_deg
+  IMPLICIT NONE
+      
+  INTEGER,INTENT(IN) :: nlon,iflag_phys
+
+  ! local variables
+  REAL :: pi
+
+  ! initializations:
+  pi=2.*ASIN(1.)
+
+  CALL phys_state_var_init()
+
+  rlat(1:klon_omp)=latitude_deg(1:klon_omp)
+  rlon(1:klon_omp)=longitude_deg(1:klon_omp)
+
+
+  ! Here you could create an initial condition for the physics
+  ! ...
+  ! ... fill in the fields...
+  ! ...
+  ! ... and create a "startphy.nc" file
+      CALL phyredem ("startphy.nc")
+
+  END SUBROUTINE iniaqua
+
+END MODULE phyaqua_mod
Index: /LMDZ5/branches/testing/libf/phymar/physiq.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phymar/physiq.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phymar/physiq.F90	(revision 2408)
@@ -11,5 +11,5 @@
      &            debut,lafin,jD_cur, jH_cur,pdtphys, &
      &            paprs,pplay,pphi,pphis,ppresnivs, &
-     &            u,v,t,qx, &
+     &            u,v,rot,t,qx, &
      &            flxmass_w, &
      &            d_u, d_v, d_t, d_qx, d_ps &
@@ -17,6 +17,6 @@
 
       USE dimphy, only : klon,klev,klevp1
-      USE infotrac, only : nqtot
-      USE comgeomphy, only : rlatd,rlond,airephy
+      USE infotrac_phy, only : nqtot
+      USE geometry_mod, only : latitude,longitude,cell_area
       !USE comcstphy, only : rg
       USE iophy, only : histbeg_phy,histwrite_phy
@@ -120,4 +120,6 @@
       real,intent(in) :: u(klon,klev) ! eastward zonal wind (m/s)
       real,intent(in) :: v(klon,klev) ! northward meridional wind (m/s)
+      REAL, intent(in):: rot(klon, klev) ! relative vorticity,
+                                         ! in s-1, needed for frontal waves
       real,intent(in) :: t(klon,klev) ! temperature (K)
       real,intent(in) :: qx(klon,klev,nqtot) ! tracers (.../kg_air)
@@ -498,11 +500,11 @@
 
 DO i=1,klon
-  IF (rlond(i) .LT. 0) THEN
-    lonh_HOST(i)=rlond(i)*12./rpi+24. ! from radians to hours
+  IF (longitude(i) .LT. 0) THEN
+    lonh_HOST(i)=longitude(i)*12./rpi+24. ! from radians to hours
    ELSE
-    lonh_HOST(i)=rlond(i)*12./rpi ! from radians to hours
+    lonh_HOST(i)=longitude(i)*12./rpi ! from radians to hours
   ENDIF
 ENDDO
-latr_HOST(:)=rlatd(:) ! from radians to radians
+latr_HOST(:)=latitude(:) ! from radians to radians
 
 !PRINT*, 'lonh_HOST(:)=',lonh_HOST(:)
@@ -689,6 +691,6 @@
 PRINT*, 'Initialisation de la temperature de surface avec les SST aquaplanète'
           DO i = 1,klon
-            Ts___HOST(i)=273.+27.*(1-sin(1.5*rlatd(i))**2)
-            IF ((rlatd(i).GT.1.0471975).OR.(rlatd(i).LT.-1.0471975)) THEN
+            Ts___HOST(i)=273.+27.*(1-sin(1.5*latitude(i))**2)
+            IF ((latitude(i).GT.1.0471975).OR.(latitude(i).LT.-1.0471975)) THEN
               Ts___HOST(i)=273.
             ENDIF
@@ -791,6 +793,6 @@
 DO k = 1, klev
   i=klev+1-k
-  !omega(i,k) = RG*flxmass_w(i,k) / airephy(i) ! omega en Pa/s
-  Wa___HOST(:,i)=flxmass_w(:,k) / airephy(:) * (gZam_HOST(:,i+1) - gZam_HOST(:,i))/(paprs(:,k+1)-paprs(:,k)) ! Equilibre hydrostatique
+  !omega(i,k) = RG*flxmass_w(i,k) / cell_area(i) ! omega en Pa/s
+  Wa___HOST(:,i)=flxmass_w(:,k) / cell_area(:) * (gZam_HOST(:,i+1) - gZam_HOST(:,i))/(paprs(:,k+1)-paprs(:,k)) ! Equilibre hydrostatique
 END DO
 Wa___HOST(:,klev)=0 ! Vitesse nulle à la surface.
@@ -853,6 +855,6 @@
 !IF (debut) THEN
   DO i=1,klon
-    sst__HOST(i)=273.+27.*(1-sin(1.5*rlatd(i))**2)
-    IF ((rlatd(i).GT.1.0471975).OR.(rlatd(i).LT.-1.0471975)) THEN
+    sst__HOST(i)=273.+27.*(1-sin(1.5*latitude(i))**2)
+    IF ((latitude(i).GT.1.0471975).OR.(latitude(i).LT.-1.0471975)) THEN
       sst__HOST(i)=273.
     ENDIF
@@ -908,6 +910,6 @@
       ikl0 = i
       PRINT*,'Attention : NaN at'
-      PRINT*,'longitude=',rlond(i)*180/rpi
-      PRINT*,'latitude=',rlatd(i)*180/rpi
+      PRINT*,'longitude=',longitude(i)*180/rpi
+      PRINT*,'latitude=',latitude(i)*180/rpi
     ENDIF
   ENDDO
Index: /LMDZ5/branches/testing/makelmdz
===================================================================
--- /LMDZ5/branches/testing/makelmdz	(revision 2407)
+++ /LMDZ5/branches/testing/makelmdz	(revision 2408)
@@ -296,7 +296,8 @@
 then
    #We'll use some physics
-   src_dirs="$src_dirs phy$physique"
+   src_dirs="$src_dirs phy_common phy$physique"
    LIBPHY='$(LIBO)/libphy'"$physique"'.a'
-   lib_phy='-lphy'"$physique"
+   LIBPHY_COMMON='$(LIBO)/libphy_common.a'
+   lib_phy='-lphy'"$physique"' -lphy_common'
    CPP_KEY="$CPP_KEY CPP_PHYS"
    if [[ $phys_root == "lmd" ]]
@@ -690,4 +691,5 @@
 "PHYS=$physique" \
 LIBPHY=${LIBPHY} \
+LIBPHY_COMMON=${LIBPHY_COMMON} \
 LIBDYN_PHYS=${LIBDYN_PHYS} \
 DIM=$dimc \
@@ -721,4 +723,5 @@
 "PHYS=$physique" \
 LIBPHY=${LIBPHY} \
+LIBPHY_COMMON=${LIBPHY_COMMON} \
 LIBDYN_PHYS=${LIBDYN_PHYS} \
 DIM=$dimc \
